/*****************************************************************************/

/*** (Final Year Project Bluetooth-Infrared Converter) bic_michael.c  	   ***/

/***                                                  Michael Cheung Ka Kin***/

/*****************************************************************************/

  

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <sys/time.h>
#include <string.h>
#include <termios.h>
#include <syslog.h>

#include <modeminit.h>
#include <modeminit.c>
#include <logging.c>
#include <logging.h>
#include <extras.h>
#include <extras.c>
#include <locking.c>
#include <locking.h>
#include <alarm.h>
#include <alarm.c>

#include <sys/file.h>

#include <mysql/mysql.h>

char filename[500] = { 0 };
char logfile[256] = { 0 };
char alarmhandler[256] = { 0 };
int alarmlevel = LOG_WARNING;
int loglevel = 9;
int ret_code;
char tmp[100];
char command[1024];//used for AT command only for creating menu
char buffer[1024];//used for AT command only when the number of choice1 is dynamic
char answer[1024];//used for the command for the Linux PC
char type[3];
char remote[20];
char *target, *user, *password;

MYSQL mysql;
MYSQL_RES *result;
MYSQL_ROW row;

void device_choice1(MYSQL *, char [], char []);
void TVcontrol(char []);
/*void CDcontrol(char []);
void VCDcontrol(char []);
void DVDcontrol(char []);
void MP3control(char []);*/

void parsearguments1()
{
	strcpy (device, "/dev/null");
	baudrate = 115200;
	errorsleeptime = 10;
	rtscts = 0;
	strcpy (modemname, device);
	}

void parsearguments ()
{
	strcpy (device, "/dev/rfcomm0");
	baudrate = 115200;
	errorsleeptime = 10;
	rtscts = 0;
	strcpy (modemname, device);
	}

void flush (char *fl,int len)
{
	int m;
	for (m=0;m<len;m++)
	{
		fl[m]='\0';
	}
}

int main (int argc, char **argv)
{
	int submenu_selected;
	int func1_selected;
	int func2_selected;
	int func3_selected;
	int func4_selected;
	int func5_selected;
	int func6_selected;
	int which_submenu;
	int type_choice1=0;
	target=user=password=NULL;
	parsearguments ();
	snprintf (tmp, sizeof (tmp), "t68_remote_v2 (%s)", modemname);
	tmp[sizeof (tmp) - 1] = 0;
	openlogfile (tmp, logfile, LOG_DAEMON, loglevel);
	set_alarmhandler (alarmhandler, alarmlevel, modemname);
	printf("\E[H\E[J"); 
	printf ("Bluetooth infrared converter\n\n");
	printf ("Doing initializations !\n");
	mysql_init(&mysql);
	if (!mysql_connect(&mysql, target, user, password)) 
	{
       	printf("Database connection failed\n");
       	return 0;
   		}
	else 
		printf("Database connection ok\n");  
	mysql_select_db(&mysql,"AVDevice");
	openmodem ();
	setmodemparams ();
	sprintf (command, "at+cscs=i\"8859-1\"\r");
	ret_code = put_command (command, answer, sizeof (answer), 5, 0);
	sprintf (command, "AT*EAM=\"Bt-IrConverter\"\r");
	ret_code = put_command (command, answer, sizeof (answer), 5, 0);
	while (1)
	{
		submenu_selected = 0;
		while (!submenu_selected)
		{
			ret_code = put_command ("", answer, sizeof (answer), 5, 0);
			submenu_selected = (NULL != strstr (answer, "*EAAI"));
			}
		while (1)
		{
			sprintf (command, "AT*EASM=\"Bt-IrConverter\",1,1,6,\"TV\",\"CD\",\"VCD\",\"DVD\",\"MP3\",\"quit\",\r");
			ret_code = put_command (command, answer, sizeof (answer), 6, 0);
	    	func1_selected = 0;
	      	func2_selected = 0;
	      	func3_selected = 0;
	      	func4_selected = 0;
			func5_selected = 0;
			func6_selected = 0;
	      	while (!func1_selected && !func2_selected && !func3_selected && !func4_selected && !func5_selected && !func6_selected)
			{
				ret_code = put_command ("", answer, sizeof (answer), 6, 0);
				func1_selected = (NULL != strstr (answer, "*EAMI: 1"));
				func2_selected = (NULL != strstr (answer, "*EAMI: 2"));
				func3_selected = (NULL != strstr (answer, "*EAMI: 3"));
				func4_selected = (NULL != strstr (answer, "*EAMI: 4"));
				func5_selected = (NULL != strstr (answer, "*EAMI: 5"));
				func6_selected = (NULL != strstr (answer, "*EAMI: 6"));
				}
	      	if (func6_selected)
				break;
	      	else if (func1_selected)
			{
				which_submenu = 1;
				printf("Mobile user selected TV\n"); 
				}
	      	else if (func2_selected)
			{
				which_submenu = 2;
				printf("Mobile user selected CD\n"); 
				}
	      	else if (func3_selected)
			{
				which_submenu = 3;
				printf("Mobile user selected VCD\n");
				}
			else if (func4_selected)
			{
				which_submenu = 4;
				printf("Mobile user selected DVD\n");
				}
			else if (func5_selected)
			{
				which_submenu = 5;
				printf("Mobile user selected MP3\n");
				}
		   	switch (which_submenu)
			{
				case 1:
					device_choice1(&mysql, "TV", remote);
					TVcontrol(remote);
					break;
				case 2:	
					device_choice1(&mysql, "CD", remote);
					//CDcontrol(remote);
					break;
				case 3:
					device_choice1(&mysql, "VCD", remote);
					//VCDcontrol(remote);
					break;
				case 4:
					device_choice1(&mysql, "DVD", remote);
					//DVDcontrol(remote);
					break;
				case 5:
					device_choice1(&mysql, "MP3", remote);
					//MP3control(remote);
					break;
				default:
					break;
					}
				}
		mysql_close(&mysql);
		printf ("Mobile user has quitted!\n");
	    exit(0); 
		sprintf(command, "AT+CMER=0,0,0,0,0\r");
		ret_code = put_command (command, answer, sizeof (answer), 5, 0);   
		}
	}

void device_choice1(MYSQL *mysql, char type[], char remote[])
{
	char query_buffer[1000];
	char buffer[1024];
	char device[100][20];
	char model[100][20];
	int item_brand;
	int item_model;
	int brand_selected=0;
    int model_selected=0;
	int db_success;
	int ans_selected[100];
	int a,b,c,i,j,k,l;
	int count1;
	int count2;
    repeat1:
    item_brand=0;
    item_model=0;
    sprintf(query_buffer, "SELECT distinct(Brand) from %s ORDER by Brand", type);
	if (mysql_query(mysql, query_buffer)==0)
	{
		db_success=1;
		result=mysql_use_result(mysql);
		while (row = mysql_fetch_row(result))
		{
			item_brand++;
            strcpy(device[item_brand-1], row[0]);
			}
      	mysql_free_result(result); 
		}
	else
	{
		printf("There is an error when showing result! \n");
		db_success=0;
		}
	if (db_success==1)
	{
	    for (i=0; i<item_brand; i++)
			printf("%d. %s \n", i+1, device[i]);
		sprintf(command, "AT*EASM=\"Bt-IrConverter\",1,1,%d", item_brand+1);
		ret_code=put_command (command, answer, sizeof (answer), 5, 0);
		for (j=0; j<item_brand; j++)
		{
			sprintf(command, ",\"%s\"", device[j]);
			ret_code=put_command (command, answer, sizeof (answer), 5, 0);
			}
		sprintf(command, ",\"quit\",\r");
		ret_code=put_command (command, answer, sizeof (answer), 5, 0);
		for (k=0; k<item_brand+1; k++)
			ans_selected[k]=0;
		count1=1;
		while (count1)
		{
			ret_code = put_command ("", answer, sizeof (answer), 5, 0);
			for (l=0; l<item_brand+1; l++)
			{
				sprintf (buffer, "*EAMI: %d", l+1);
				ans_selected[l] = (NULL != strstr (answer, buffer));
				if (ans_selected[l]==1)
				{
					count1=0;
					brand_selected=l;
					break;
					}
				}
			}
	    if (ans_selected[item_brand])
			goto repeat1;
		else 
        {
			printf("You have chosen %s %s \n", device[brand_selected], type);
			sprintf(query_buffer, "SELECT Model from %s WHERE Brand='%s' ORDER by Model", type, device[brand_selected]);
			if (mysql_query(mysql, query_buffer)==0)
			{
				db_success=1;
				result=mysql_use_result(mysql);
				while (row = mysql_fetch_row(result))
				{
					item_model++;
					strcpy(model[item_model-1], row[0]);
					}
      				mysql_free_result(result); 
				}
			else 
			{
				printf("There is an error when showing result! \n");
				db_success=0;
				}
			if (db_success==1)
			{
				sprintf(command, "AT*EASM=\"Bt-IrConverter\",1,1,%d", item_model+1);
				ret_code=put_command (command, answer, sizeof (answer), 5, 0);
				for (a=0; a<item_model; a++)
				{
					sprintf(command, ",\"%s\"", model[a]);
					ret_code=put_command (command, answer, sizeof (answer), 5, 0);
					}
				sprintf(command, ",\"quit\",\r");
				ret_code=put_command (command, answer, sizeof (answer), 5, 0);
				for (b=0; b<item_model+1; b++)
					ans_selected[b]=0;
				count2=1;
				while (count2)
				{
					ret_code = put_command ("", answer, sizeof (answer), 5, 0);
					for (c=0; c<item_model+1; c++)
					{
						sprintf (buffer, "*EAMI: %d", c+1);
						ans_selected[c] = (NULL != strstr (answer, buffer));
						if (ans_selected[c]==1)
						{
							count2=0;
							model_selected=c;
							break;
							}
						}
					}
				if (ans_selected[item_model])
					goto repeat1;
				else
				{
					strcpy(remote, model[model_selected]);
					printf("You have chosen %s %s %s \n", device[brand_selected],  remote, type);
				}
			}
		}
	}
}

void TVcontrol(char remote[])
{
	char instruct[1024];
	int item_choice1=0;
	int ans_select[100];
	int con;
	int channel1;
	int channel2;
	int a,b,c,d,e,f,g,h,i;
	int choice1;
	int choice2;
	int menu_count;
	int channel_count=0;
	TV:
	sprintf (command, "AT*EASM=\"TV\",1,1,7,\"Power\",\"Channel\",\"Volume\",\"Menu\",\"Language\",\"Others\",\"quit\",\r");
	ret_code = put_command (command, answer, sizeof (answer), 5, 0);
	for (a=0; a<7; a++)
		ans_select[a]=0;
	choice1=1;
	while (choice1)
	{
		ret_code=put_command ("", answer, sizeof (answer), 5, 0);
		for (b=0; b<7; b++)
		{
			sprintf (buffer, "*EAMI: %d", b+1);
			ans_select[b] = (NULL != strstr (answer, buffer));
			if (ans_select[b]==1)
			{
				choice1=0;
				con=b+1;
				break;
				}
			}
		}
	if (ans_select[6])
		return;
	else
	{
		switch (con)
		{
			case 1:
				sprintf(instruct, "/usr/local/irtrans/irclient localhost %s power", remote);
				system(instruct);
				printf("The user has turn on/off the TV \n");
				break;
			case 2:
				channel:
				sprintf (command, "AT*EASM=\"Channel\",1,1,3,\"0-9?\",\"10 or above?\",\"quit\",\r");
				ret_code = put_command (command, answer, sizeof (answer), 5, 0);
				for (c=0; c<3; c++)
					ans_select[c]=0;
				while (!ans_select[0] && !ans_select[1] && !ans_select[2])
				{
					ret_code = put_command ("", answer, sizeof (answer), 5, 0);
					ans_select[0]=(NULL!=strstr(answer, "*EAMI: 1"));
					ans_select[1]=(NULL!=strstr(answer, "*EAMI: 2"));
					ans_select[2]=(NULL!=strstr(answer, "*EAMI: 3"));
					}
				if (ans_select[2])
					break;
				else if (ans_select[0])
				{
					sprintf (command, "AT*EASM=\"channel\",1,1,11,\"0\",\"1\",\"2\",\"3\",\"4\",\"5\",\"6\",\"7\",\"8\",\"9\",\"quit\",\r");
					ret_code = put_command (command, answer, sizeof (answer), 5, 0);
					for (d=0; d<11; d++)
						ans_select[d]=0;
					choice1=1;
					while (choice1)
					{
						ret_code=put_command ("", answer, sizeof (answer), 5, 0);
						for (e=0; e<11; e++)
						{
							sprintf (buffer, "*EAMI: %d", e+1);
							ans_select[e] = (NULL != strstr (answer, buffer));
							if (ans_select[e]==1)
							{
								choice1=0;
								channel1=e;
								break;
								}
							}
						}
					if (ans_select[10])
						goto channel;
					else
					{
						sprintf(instruct, "/usr/local/irtrans/irclient localhost %s %d", remote, channel1);
						system(instruct);
						printf("Mobile user selected channel %d\n", channel1);
						goto TV;
						}
					}
				else if (ans_select[1])
				{
					sprintf (command, "AT*EASM=\"channel_tens?\",1,1,10,\"1\",\"2\",\"3\",\"4\",\"5\",\"6\",\"7\",\"8\",\"9\",\"quit\",\r");
					ret_code = put_command (command, answer, sizeof (answer), 5, 0);
					for (f=0; f<10; f++)
						ans_select[f]=0;
					choice1=1;
					while (choice1)
					{
						ret_code=put_command ("", answer, sizeof (answer), 5, 0);
						for (g=0; g<10; g++)
						{
							sprintf (buffer, "*EAMI: %d", g+1);
							ans_select[g] = (NULL != strstr (answer, buffer));
							if (ans_select[g]==1)
							{
								choice1=0;
								channel1=g;
								break;
								}
							}
						}
					if (ans_select[9])
						goto channel;
					else
					{
						sprintf (command, "AT*EASM=\"channel_ones?\",1,1,11,\"0\",\"1\",\"2\",\"3\",\"4\",\"5\",\"6\",\"7\",\"8\",\"9\",\"quit\",\r");
						ret_code=put_command (command, answer, sizeof (answer), 5, 0);
						for (h=0; h<11; h++)
						ans_select[h]=0;
						choice2=1;
						while (choice2)
						{
							ret_code=put_command ("", answer, sizeof (answer), 5, 0);
							for (i=0; i<11; i++)
							{
								sprintf (buffer, "*EAMI: %d", i+1);
								ans_select[i] = (NULL != strstr (answer, buffer));
								if (ans_select[i]==1)
								{
									choice2=0;
									channel2=i;
									}
								}
							}
						if (ans_select[10])
							goto channel;
						else
						{
							sprintf(instruct, "/usr/local/irtrans/irclient localhost %s 10+", remote);
							system(instruct);
							sprintf(instruct, "/usr/local/irtrans/irclient localhost %s %d", remote, channel1);
							system(instruct);
							sprintf(instruct, "/usr/local/irtrans/irclient localhost %s %d", remote, channel2);
							system(instruct);
							printf("Mobile user selected channel %d\n", channel1*10+channel2);
							channel_count++;
							if (channel_count==2)
							{
								sprintf(instruct, "/usr/local/irtrans/irclient localhost %s 10+", remote);
								system(instruct);
								channel_count=0;
								}
							goto TV;
							}
						}
				}
				break;
			case 3:
				vol:
				sprintf (command, "AT*EASM=\"Volume\",1,1,3,\"increase vol?\",\"decrease vol?\",\"quit\",\r");
				ret_code = put_command (command, answer, sizeof (answer), 5, 0);
				for (c=0; c<3; c++)
					ans_select[c]=0;
				while (!ans_select[0] && !ans_select[1] && !ans_select[2])
				{
					ret_code = put_command ("", answer, sizeof (answer), 5, 0);
					ans_select[0]=(NULL!=strstr(answer, "*EAMI: 1"));
					ans_select[1]=(NULL!=strstr(answer, "*EAMI: 2"));
					ans_select[2]=(NULL!=strstr(answer, "*EAMI: 3"));
					}
				if (ans_select[2])
					break;
				else
                {
					if (ans_select[0])
					{
						sprintf(instruct, "/usr/local/irtrans/irclient localhost %s upvol", remote);
						system(instruct);
						printf("Mobile user selected to increase volume\n");
						}
					else if (ans_select[1])
					{
						sprintf(instruct, "/usr/local/irtrans/irclient localhost %s downvol", remote);
						system(instruct);
						printf("Mobile user selected to decrease volume\n");
						}
                    goto vol;
					}
				break;
			case 4:
				menu_count=0;
				sprintf(instruct, "/usr/local/irtrans/irclient localhost %s menu", remote);
				system(instruct);
				printf("Mobile user entered to menu\n");
				menu:
				sprintf(command, "AT*EASM=\"Menu\",1,1,6,\"up\",\"down\",\"left\",\"right\",\"Menu\",\"quit\",\r");
				ret_code = put_command (command, answer, sizeof (answer), 5, 0);
				for (d=0; d<6; d++)
					ans_select[d]=0;
				choice1=1;
				while (choice1)
				{
					ret_code=put_command ("", answer, sizeof (answer), 5, 0);
					for (e=0; e<6; e++)
					{
						sprintf (buffer, "*EAMI: %d", e+1);
						ans_select[e]=(NULL != strstr (answer, buffer));
						if (ans_select[e]==1)
						{
							choice1=0;
							break;
							}
						}
					}
				if (ans_select[5])
					break;
				else
				{
					if (ans_select[0])
					{
						sprintf(instruct, "/usr/local/irtrans/irclient localhost %s upchannel", remote);
						system(instruct);
						goto menu;
						}
					else if (ans_select[1])
					{
						sprintf(instruct, "/usr/local/irtrans/irclient localhost %s downchannel", remote);
						system(instruct);
						goto menu;
						}
					else if (ans_select[2])
					{
						sprintf(instruct, "/usr/local/irtrans/irclient localhost %s downvol", remote);
						system(instruct);
						goto menu;
						}
					else if (ans_select[3])
					{
						sprintf(instruct, "/usr/local/irtrans/irclient localhost %s upvol", remote);
						system(instruct);
						goto menu;
						}
					else if (ans_select[4])
					{
						sprintf(instruct, "/usr/local/irtrans/irclient localhost %s menu", remote);
						system(instruct);
						printf("Mobile user selected an item\n");
						menu_count++;
						if (menu_count==1)
							goto menu;
						else 
							goto TV;
						}
					}
				break;
			case 5:
				sprintf(instruct, "/usr/local/irtrans/irclient localhost %s lang", remote);
				system(instruct);
				printf("Mobile user selected to change language\n");
			case 6:
				Other:
				sprintf (command, "AT*EASM=\"Others\",1,1,4,\"Mode\",\"Silent\",\"Call\",\"quit\",\r");
				ret_code = put_command (command, answer, sizeof (answer), 5, 0);
				for (f=0; f<4; f++)
					ans_select[f]=0;
				while (!ans_select[0] && !ans_select[1] && !ans_select[2] && !ans_select[3])
				{
					ret_code = put_command ("", answer, sizeof (answer), 5, 0);
					ans_select[0]=(NULL!=strstr(answer, "*EAMI: 1"));
					ans_select[1]=(NULL!=strstr(answer, "*EAMI: 2"));
					ans_select[2]=(NULL!=strstr(answer, "*EAMI: 3"));
					ans_select[3]=(NULL!=strstr(answer, "*EAMI: 4"));
					}
				if (ans_select[3])
					break;
	      		else if (ans_select[0])
				{
					sprintf(instruct, "/usr/local/irtrans/irclient localhost %s mode", remote);
					system(instruct);
					printf("Mobile user selected to change display mode\n");
					goto Other;
					}
				else if (ans_select[1])
				{
					sprintf(instruct, "/usr/local/irtrans/irclient localhost %s silent", remote);
					system(instruct);
					printf("Mobile user selected to let the TV silent\n");
					goto Other;
					}
				else if (ans_select[2])
				{
					sprintf(instruct, "/usr/local/irtrans/irclient localhost %s call", remote);
					system(instruct);
					printf("Mobile user selected to call something\n");
					goto Other;
					}
				break;
			default:
				break;
			}
		goto TV;
		}
	}
